const fs = require ("fs"); 
var whenLastTabSwitch = new Date (), urlLastRiverGet;
var urlPrefsDialogHtml = "http://rss2.io/code/electron/prefsdialog.html?x=26";

//electron shell stuff -- 3/23/17 by DW
	function shellSetupSystemMenus () { 
		const electron = require ("electron"), remote = electron.remote, app = remote.app, Menu = remote.Menu;
		app.setName (serverConfig.productnameForDisplay); 
		var template = [
			{ //Edit menu
				label: 'Edit',
				submenu: [
					{
						label: 'Undo',
						accelerator: 'CmdOrCtrl+Z',
						role: 'undo'
						},
					{
						label: 'Redo',
						accelerator: 'Shift+CmdOrCtrl+Z',
						role: 'redo'
						},
					{
						type: 'separator'
						},
					{
						label: 'Cut',
						accelerator: 'CmdOrCtrl+X',
						role: 'cut'
						},
					{
						label: 'Copy',
						accelerator: 'CmdOrCtrl+C',
						role: 'copy'
						},
					{
						label: 'Paste',
						accelerator: 'CmdOrCtrl+V',
						role: 'paste'
						},
					{
						label: 'Select All',
						accelerator: 'CmdOrCtrl+A',
						role: 'selectall'
						},
					]
				},
			{ //Window menu
				label: 'Window',
				role: 'window',
				submenu: [
					{
						label: 'Minimize',
						accelerator: 'CmdOrCtrl+M',
						role: 'minimize'
						},
					{
						label: 'Close',
						accelerator: 'CmdOrCtrl+W',
						role: 'close'
						},
					{
						type: 'separator'
						},
					{
						label: 'Reload',
						accelerator: 'CmdOrCtrl+R',
						click: function(item, focusedWindow) {
							if (focusedWindow)
								focusedWindow.reload();
							}
						},
					{
						label: 'JavaScript console...',
						accelerator: (function() {
							if (process.platform == 'darwin')
								return 'Alt+Command+I';
							else
								return 'Ctrl+Shift+I';
							})(),
						click: function(item, focusedWindow) {
							if (focusedWindow)
								focusedWindow.toggleDevTools();
							}
						}
					]
				},
			];
		if (process.platform == 'darwin') {
			const dialog = remote.dialog;
			var aboutDialogOptions = {
				type: "info",
				title: "About Dialog",
				buttons: ["OK"],
				message: serverConfig.productnameForDisplay + " v" + appConsts.version,
				detail: serverConfig.description
				};
			template.unshift ({
				label: serverConfig.productnameForDisplay,
				submenu: [
					{
						label: 'About ' + serverConfig.productnameForDisplay + "...",
						click: function () {
							dialog.showMessageBox (aboutDialogOptions);
							}
						},
					{
						type: 'separator'
						},
					{
						label: 'Services',
						role: 'services',
						submenu: []
						},
					{
						type: 'separator'
						},
					{
						label: 'Hide ' + name,
						accelerator: 'Command+H',
						role: 'hide'
						},
					{
						label: 'Hide Others',
						accelerator: 'Command+Alt+H',
						role: 'hideothers'
						},
					{
						label: 'Show All',
						role: 'unhide'
						},
					{
						type: 'separator'
						},
					{
						label: 'Quit',
						accelerator: 'Command+Q',
						click: function () {app.quit ();}
						},
					]
				});
			}
		
		var theMenu = Menu.buildFromTemplate (template);
		Menu.setApplicationMenu (theMenu);
		}
	function shellSetupIpcHandlers () {
		console.log ("setupIpcHandlers");
		const ipcRenderer = require ("electron").ipcRenderer;
		ipcRenderer.on ("debugMessage", function (event, s) {
			console.log (s + " [main thread]");
			});
		ipcRenderer.on ("webSocketCallback", function (event, s) {
			webSocketProcessMessage (s);
			});
		ipcRenderer.on ("statsChangedCallback", function (event, jsontext) {
			dashboardStatsChanged (jsontext);
			});
		ipcRenderer.send ("asynch-message", "hello");  //so the main thread knows how to call us
		}
	function shellOpenUrl (url) {
		require ("electron").ipcRenderer.send ("asynch-message", "openUrl", url);  
		}
	function shellOpenFolder (folder) {
		require ("electron").ipcRenderer.send ("asynch-message", "openFolder", folder);  
		}
	function shellHttpRequest (path, method, callback) { //call into the River5 server, running over in Node-Land
		var electron = require ("electron");
		if (method === undefined) {
			method = "GET";
			}
		electron.ipcRenderer.once ("httpReturnVal", function (event, headers, val) {
			if (callback !== undefined) {
				callback (val);
				}
			});
		electron.ipcRenderer.send ("asynch-message", "httpRequest", method, path);  
		}
	function shellGetRiver (url, callback) {
		shellHttpRequest ("/" + url, "GET", function (jsText) {
			function onGetRiverStream (data) {
				riverBrowserData.theRiver = data;
				freshRiverDisplay ("idRiverDisplay");
				if (callback != undefined) {
					callback ();
					}
				}
			eval (jsText);
			});
		}
	function shellReadAllFeedsNow () { //4/18/17 by DW
		require ("electron").ipcRenderer.send ("asynch-message", "readAllFeedsNow");  
		}
	
	function shellGetConfig () { //4/21/17 by DW
		var theConfig = JSON.parse (require ("electron").ipcRenderer.sendSync ("synchronous-message", "getConfig")); 
		return (theConfig);
		}
	function shellSetConfig (theConfigSubset) { //4/21/17 by DW
		require ("electron").ipcRenderer.send ("asynch-message", "setConfig", jsonStringify (theConfigSubset));  
		}
	
	
	function testHttp (path) {
		shellHttpRequest (path, undefined, function (value) {
			console.log ("Inside the callback: value == " + value);
			});
		}
//websockets -- 2/1/16 by DW
	var mySocket = undefined;
	
	function webSocketProcessMessage (s) {
		var words = s.split (" ");
		if (words.length >= 2) { //new protocol as of 11/29/15 by DW
			switch (words [0]) {
				case "updated":
					var listname = stringPopExtension (stringLower (trimWhitespace (words [1]))) + ".js";;
					console.log ("webSocketClient, list updated: listname == " + listname);
					for (var x in appPrefs.myRivers) {
						var thislistname = stringLower (stringNthField (appPrefs.myRivers [x], "=", 2));
						console.log (thislistname);
						if (listname == thislistname) {
							if (stringLower (x) == stringLower (appPrefs.currentPanelName)) {
								console.log ("webSocketClient, updating the river: url == " + appPrefs.myRivers [x]);
								shellGetRiver (appPrefs.myRivers [x]);
								}
							break;
							}
						}
					break;
				case "readfeed":
					var urlfeed = trimWhitespace (words [1]);
					break;
				case "item":
					var jsontext = stringDelete (s, 1, 5); //pop off "item "
					break;
				default:
					console.log (words [0] + words [1]);
					break;
				}
			}
		}
	function webSocketClient (s) {
		var splitUrl = urlSplitter (window.location.href), host;
		var urlSocket = "ws://localhost:" + serverConfig.webSocketPort + "/";
		console.log ("webSocketClient: urlSocket == " + urlSocket);
		
		mySocket = new WebSocket (urlSocket); 
		mySocket.onopen = function (evt) {
			console.log ("mySocket is open.");
			console.log ("sending: " + s);
			mySocket.send (s);
			};
		mySocket.onmessage = function (evt) {
			webSocketProcessMessage (evt.data.toString ());
			};
		mySocket.onclose = function (evt) {
			console.log ("mySocket was closed.");
			mySocket = undefined;
			};
		mySocket.onerror = function (evt) {
			console.log ("mySocket received an error");
			};
		}
//commands 
	function applyPrefs () {
		}
	function openSettingsDialog () {
		var theConfig = shellGetConfig (); 
		console.log ("openSettingsDialog: theConfig == " + jsonStringify (theConfig));
		appPrefs.flDownloadPodcasts = theConfig.flDownloadPodcasts; 
		appPrefs.podcastsFolder = theConfig.podcastsFolder; 
		appPrefs.flOpenDevToolsAtStart = theConfig.flOpenDevToolsAtStart; 
		prefsDialogShow (function () {
			var configChanges = {
				flDownloadPodcasts: appPrefs.flDownloadPodcasts,
				podcastsFolder: appPrefs.podcastsFolder,
				flOpenDevToolsAtStart: appPrefs.flOpenDevToolsAtStart
				};
			console.log ("About to shellSetConfig, configChanges == " + jsonStringify (configChanges));
			shellSetConfig (configChanges);
			});
		}
	function readAllFeedsNowCommand () {
		confirmDialog ("Read all feeds now?", function () {
			shellReadAllFeedsNow ();
			});
		}
//dashboard
	var riverStats, river5FeedsArray;
	var flDashboardOpen = false;
	
	function dashboardStatsChanged (jsontext) {
		riverStats = JSON.parse (jsontext);
		if (flDashboardOpen) {
			river5UpdateStatsDisplay ();
			}
		}
	function river5UpdateStatsDisplay () {
		var htmltext = "", indentlevel = 0;
		function findInFeedsArray (urlfeed) {
			if (river5FeedsArray != undefined) {
				var lowerfeed = urlfeed.toLowerCase (), flfound = false, ixfeed;
				for (var i = 0; i < river5FeedsArray.length; i++) {
					if (river5FeedsArray [i].url.toLowerCase () == lowerfeed) {
						var feedstats = river5FeedsArray [i];
						return (feedstats);
						}
					}
				}
			return (undefined);
			}
		
		function add (s) {
			htmltext += filledString ("\t", indentlevel) + s + "\n";
			}
		function addrow (label, val) {
			add ("<tr><td class=\"tdLabel\"><div class=\"divDashboardText\">" + label + ":</div></td><td class=\"tdVal\"><div class=\"divDashboardText\">" + val + "</div></td></tr>")
			}
		function getWhenString (when) {
			var ctSecsSinceLastStart = (new Date () - new Date (when)) / 1000;
			var cthours = Number (ctSecsSinceLastStart) / 3600, s;
			if (cthours < 1) {
				s = (cthours * 60).toFixed (2) + " minutes";
				}
			else {
				s = cthours.toFixed (2) + " hours"
				}
			return (s);
			}
		function serverUpHours () {
			return (getWhenString (riverStats.whenLastStart));
			}
		function howLongSinceLastRead () {
			return (getWhenString (riverStats.whenLastFeedRead));
			}
		function lastFeedRead () {
			var lastreadlink = "";
			if (river5FeedsArray != undefined) {
				var feedstats = findInFeedsArray (lastreadlink);
				lastreadlink = riverStats.lastFeedRead; 
				if (feedstats != undefined) {
					lastreadlink = "<a href=\"" + lastreadlink + "\">" + feedstats.title + "</a>"
					}
				}
			return (lastreadlink);
			}
		function lastStoryAdded () {
			var s = "";
			if (riverStats.lastStoryAdded != undefined) {
				var item = riverStats.lastStoryAdded;
				if (item.title != undefined) {
					s = maxStringLength (item.title, 50);
					if (item.link != undefined) {
						s = "<a href=\"" + item.link + "\" target=\"_blank\">" + s + "</a>";
						}
					}
				}
			return (s);
			}
		add ("<table>"); indentlevel++;
		addrow ("Aggregator", riverStats.aggregator);
		addrow ("Server up", serverUpHours ());
		addrow ("Feeds read (this run)", stringAddCommas (riverStats.ctFeedReadsThisRun));
		addrow ("New stories (this run)", stringAddCommas (riverStats.ctStoriesAddedThisRun));
		addrow ("Number of hits (this run)", stringAddCommas (riverStats.ctHitsThisRun));
		addrow ("How long since last feed read", howLongSinceLastRead ());
		add ("</table>"); indentlevel--;
		
		$("#idServerStats").html (htmltext);
		}
	function river5StatsEveryFewSeconds () { //do this every two seconds
		shellHttpRequest ("/serverdata", undefined, function (jsontext) {
			console.log ("river5StatsEveryFewSeconds: jsontext == " + jsontext); //11/16/16 by DW
			riverStats = JSON.parse (jsontext);
			river5UpdateStatsDisplay ();
			});
		}
	function river5UpdateFeedsArray () { //do this once a minute
		shellHttpRequest ("/feedstats", undefined, function (jsontext) {
			river5FeedsArray = JSON.parse (jsontext);
			river5UpdateStatsDisplay ();
			});
		}
	function openServerDashboard () {
		flDashboardOpen = true;
		$("#idServerDashboard").modal ("show"); 
		river5StatsEveryFewSeconds ();
		}
	function closeServerDashboard () {
		flDashboardOpen = false;
		$("#idServerDashboard").modal ("hide"); 
		}
//list editor
	var mySubList = [
		];
	
	
	
	function xmlGetSubsFromOpml (opmltext) { //3/27/17 by DW
		function myOneLevelVisit (adrx, callback) { //it doesn't expand includes
			$(adrx).children ("outline").each (function () {
				if (callback !== undefined) {
					if (!callback (this)) {
						return (false);
						}
					}
				return (true);
				});
			}
		function gatherSubs (adrx) {
			myOneLevelVisit (adrx, function (adrsub) {
				if (xmlHasSubs (adrsub)) {
					gatherSubs (adrsub);
					}
				else {
					var atts = new Object ();
					xmlGatherAttributes (adrsub, atts);
					subsArray.push (atts);
					}
				return (true);
				});
			}
		console.log ("xmlGetSubsFromOpml: just passin through.");
		var xstruct = xmlCompile (opmltext);
		var adrbody = getXstuctBody (xstruct);
		var subsArray = [];
		gatherSubs (adrbody);
		return (subsArray);
		}
	
	
	
	function copyFromListEditorToSubList () {
		var table = document.getElementById ("idSubListTable");
		for (i = 0; i < table.rows.length; i++) {
			var row = table.rows [i]
			var title = row.cells [0].childNodes [0].value;
			var url = row.cells [1].childNodes [0].value;
			mySubList [i].text = title;
			if (mySubList [i].type == "include") {
				mySubList [i].url = url;
				}
			else {
				mySubList [i].xmlUrl = url;
				}
			}
		}
	function subListToOpml (whenCreated) {
		var opmltext = "", indentlevel = 0, now = new Date ();
		function add (s) {
			opmltext += filledString ("\t", indentlevel) + s + "\r\n";
			}
		function encode (s) {
			if (s === undefined) {
				return ("");
				}
			return (encodeXml (s));
			}
		if (whenCreated === undefined) {
			whenCreated = now;
			}
		add ("<?xml version=\"1.0\"?>");
		add ("<opml version=\"2.0\">"); indentlevel++;
		//add head
			add ("<head>"); indentlevel++;
			add ("<title>" + encode (appPrefs.currentList) + "</title>");
			add ("<dateCreated>" + new Date (whenCreated).toUTCString () + "</dateCreated>");
			add ("<dateModified>" + now.toUTCString () + "</dateModified>");
			add ("</head>"); indentlevel--;
		add ("<body>"); indentlevel++;
		//add the <outline> elements
			var table = document.getElementById ("idSubListTable");
			for (i = 0; i < table.rows.length; i++) {
				var row = table.rows [i]
				var title = row.cells [0].childNodes [0].value;
				var url = row.cells [1].childNodes [0].value;
				var atts = {
					type: "rss"
					};
				for (var j = 0; j < mySubList.length; j++) {
					var urlToCompare;
					if (mySubList [j].type == "include") {
						urlToCompare = mySubList [j].url;
						}
					else {
						urlToCompare = mySubList [j].xmlUrl;
						}
					if (urlToCompare == url) {
						atts = mySubList [j];
						break;
						}
					}
				atts.text = title;
				if (atts.type == "include") {
					atts.url = url;
					}
				else {
					atts.xmlUrl = url;
					}
				var s = "<outline ";
				for (var x in atts) {
					s += x + "=\"" + encode (atts [x]) + "\" ";
					}
				s += "/>";
				add (s);
				}
		add ("</body>"); indentlevel--;
		add ("</opml>"); indentlevel--;
		return (opmltext);
		}
	function readSubList (callback) {
		var f = serverConfig. listsFolder + serverConfig.fnameInitialSubscriptionList;
		fs.readFile (f, function (err, data) {
			if (!err) {
				mySubList = xmlGetSubsFromOpml (data.toString ());
				}
			if (callback !== undefined) {
				callback ();
				}
			});
		}
	function writeSubList (callback) {
		var f = serverConfig. listsFolder + serverConfig.fnameInitialSubscriptionList, opmltext = subListToOpml ();
		fs.writeFile (f, opmltext, function (err, data) {
			if (err) {
				console.log ("writeSubList: error writing OPML file == " + err.message);
				}
			if (callback !== undefined) {
				callback ();
				}
			});
		}
	function addSubListRow (theSub, flSetFocus, flAtTop) {
		var table = document.getElementById ("idSubListTable"), xmlUrl;
		var ixInsert = flAtTop ? 0 : -1;
		var row = table.insertRow (ixInsert);
		var aTitle = " title=\"" + theSub.text + "\"";
		
		if (theSub.type == "include") { //3/31/17 by DW
			xmlUrl = theSub.url;
			}
		else {
			xmlUrl = theSub.xmlUrl;
			}
		
		var cell1 = row.insertCell (0);
		var cell2 = row.insertCell (1);
		var cell3 = row.insertCell (2);
		
		cell1.innerHTML = "<input class=\"inputPodcastName\" type=\"text\" value=\"" + encodeXml (theSub.text) + "\">"; 
		cell2.innerHTML = "<input type=\"text\" value=\"" + encodeXml (xmlUrl) + "\">"; 
		cell3.innerHTML = "<div class=\"divDeleteIcon\"><a onclick=\"deleteSubListRow (this)\"><i class=\"fa fa-trash-o\"></i></a></div>";
		
		if (flSetFocus) {
			cell1.firstChild.focus ();
			}
		}
	function deleteSubListRow (theRow) {
		var table = document.getElementById ("idSubListTable");
		var ixrow = theRow.parentNode.parentNode.parentNode.rowIndex;
		table.deleteRow (ixrow);
		mySubList.splice (ixrow, 1);
		}
	function emptySubList () {
		var table = document.getElementById ("idSubListTable");
		$(table).empty ();
		}
	function sortSubList () {
		var origArray = mySubList, newArray = [];
		copyFromListEditorToSubList ();
		for (var i = 0; i < origArray.length; i++) {
			var ixMinTitle = undefined, minTitle = undefined;
			for (var j = 0; j < origArray.length; j++) {
				if (origArray [j] != undefined) {
					var s = origArray [j].text.toLowerCase ();
					if ((minTitle === undefined) || (s < minTitle)) {
						ixMinTitle = j;
						minTitle = s;
						}
					}
				}
			if (ixMinTitle != undefined) {
				newArray [newArray.length] = origArray [ixMinTitle];
				origArray [ixMinTitle] = undefined;
				}
			}
		mySubList = newArray; 
		updateSubList ();
		}
	function updateSubList () {
		emptySubList ();
		for (var i = 0; i < mySubList.length; i++) {
			addSubListRow (mySubList [i], false, false);
			}
		}
	function viewSubList (callback) {
		readSubList (function () {
			updateSubList ();
			if (callback !== undefined) {
				callback ();
				}
			});
		}
	function openSubListEditor (callback) {
		$("#idRiversBody").css ("display", "none");
		viewSubList ();
		$("#idSubList").css ("display", "block");
		}
	function sortSubListButtonClick () {
		console.log ("sortSubListButtonClick");
		sortSubList ();
		}
	function saveSubListButtonClick () {
		console.log ("saveSubListButtonClick");
		writeSubList ();
		}
	function addSubListButtonClick () {
		var initialRowVals = {
			text: "",
			xmlUrl: "",
			type: "rss"
			};
		console.log ("addSubListButtonClick");
		addSubListRow (initialRowVals, true, true);
		mySubList.unshift (initialRowVals);
		}
//pages menu
	var pagesMenuItems = [
		"River", 
		"List editor"
		];
	var currentPage = "River";
	
	function switchToPage (namePage) {
		function makePageVisible (idVisiblePage) {
			if (idVisiblePage != "idRiversBody") {
				$("#idRiversBody").css ("display", "none");
				}
			if (idVisiblePage != "idSubList") {
				$("#idSubList").css ("display", "none");
				}
			if (idVisiblePage != "idEventLog") {
				$("#idEventLog").css ("display", "none");
				}
			$("#" + idVisiblePage).css ("display", "block");
			}
		console.log ("switchToPage: namePage == " + namePage);
		switch (namePage) {
			case "River":
				makePageVisible ("idRiversBody");
				break;
			case "List editor": 
				openSubListEditor (function () {
					makePageVisible ("idSubList");
					});
				break;
			case "Event log":
				makePageVisible ("idEventLog");
				break;
			}
		currentPage = namePage;
		buildPagesMenu ();
		}
	function buildPagesMenu () {
		$("#idPagesList").empty ();
		for (var i = 0; i < pagesMenuItems.length; i++) {
			var pageName = pagesMenuItems [i], itemtext = pageName;
			var theScript = "switchToPage ('" + pageName + "')";
			var liMenuItem = $("<li></li>");
			var menuItemNameLink = $("<a></a>");
			if (pageName == currentPage) { 
				itemtext = "<i class=\"fa fa-check iMenuCheck\"></i>" + pageName;
				}
			menuItemNameLink.html (itemtext);
			menuItemNameLink.attr ("onclick", theScript);
			liMenuItem.append (menuItemNameLink);
			$("#idPagesList").append (liMenuItem);
			}
		}

function panelExists (panelname) {
	panelname = panelname.toLowerCase ();
	for (var tabname in appPrefs.myRivers) { 
		if (tabname.toLowerCase () == panelname) {
			return (true);
			}
		}
	return (false);
	}
function getFirstPanelName () {
	for (var x in appPrefs.myRivers) { 
		return (x);
		}
	}
function buildTabs () { 
	$("#idTabList").empty ();
	for (var tabname in appPrefs.myRivers) { 
		var activetab = "", lowername = tabname.toLowerCase ();
		
		if (lowername == appPrefs.currentPanelName) {
			activetab = " class=\"active\""
			}
		
		var clickScript = "switchPanel (\"" + lowername + "\")";
		$("#idTabList").append ("<li" + activetab + " id='" + tabname + "'><a data-toggle=\"tab\" onclick='" + clickScript + "'>"  + tabname + "</a></li>");
		}
	}
function switchPanel (panelname) {
	var jsonFeed;
	console.log ("switchPanel: panelname == " + panelname);
	if (panelname == "null") {
		if (appPrefs.currentPanelName.length > 0) {
			panelname = appPrefs.currentPanelName;
			}
		else {
			panelname = getFirstPanelName ();
			}
		}
	panelname = panelname.toLowerCase ();
	for (var tabname in appPrefs.myRivers) { 
		if (tabname.toLowerCase () == panelname) {
			appPrefs.currentPanelName = panelname;
			jsonFeed = appPrefs.myRivers [tabname];
			break;
			}
		}
	if (jsonFeed === undefined) { //defensive driving -- use the first panel -- 2/5/16 by DW
		for (var x in appPrefs.myRivers) {
			jsonFeed = appPrefs.myRivers [x];
			appPrefs.currentPanelName = x.toLowerCase ();
			break;
			}
		}
	buildTabs ();
	console.log ("switchPanel: jsonFeed == " + jsonFeed);
	shellGetRiver (jsonFeed);
	whenLastTabSwitch = new Date ();
	}
function capitalizeFirstLetter (s) {
	return (s.charAt (0).toUpperCase () + s.slice (1));
	}
function everyMinute () {
	if (flDashboardOpen) {
		river5UpdateFeedsArray ();
		}
	}
function everyTwoSeconds () {
	}
function everySecond () {
	if (mySocket === undefined) { //try to open the connection
		if (serverConfig.flWebSocketEnabled) {
			webSocketClient ("hello world");
			}
		}
	if (flDashboardOpen) {
		river5UpdateStatsDisplay ();
		}
	}
function startup () {
	function loadPrefsDialogHtml () { 
		readHttpFile (urlPrefsDialogHtml, function (htmltext) {
			if (htmltext === undefined) { 
				console.log ("loadPrefsDialogHtml: error loading the HTML.");
				}
			else {
				console.log ("loadPrefsDialogHtml: htmltext.length == " + htmltext.length);
				$("#idPrefsDialogPlace").html (htmltext);
				}
			});
		}
	function setupPanels (callback) {
		console.log ("setupPanels: serverConfig == " + jsonStringify (serverConfig));
		if ((serverConfig.homePage !== undefined) && (serverConfig.homePage.panels !== undefined)) { 
			appPrefs.myRivers = new Object ();
			console.log ("setupPanels: getting panel names from serverConfig.homePage.");
			for (var i = 0; i < serverConfig.homePage.panels.length; i++) {
				var item = serverConfig.homePage.panels [i];
				var urlRiver = "getoneriver?fname=" + item.river;
				appPrefs.myRivers [item.title] = urlRiver;
				console.log ("setupPanels: " + item.title + " == " + urlRiver);
				}
			if (callback !== undefined) {
				callback ();
				}
			}
		else {
			shellHttpRequest ("/getlistnames", "GET", function (jsontext) { //fall back to getting panel list from server
				if (jsontext !== undefined) {
					var listnames = JSON.parse (jsontext);
					appPrefs.myRivers = new Object ();
					for (var i = 0; i < listnames.length; i++) {
						var tabLabel = stringPopExtension (listnames [i]);  //turn iowa.opml to iowa
						var urlRiver = "getoneriver?fname=" + tabLabel + ".js";
						appPrefs.myRivers [capitalizeFirstLetter (tabLabel)] = urlRiver;
						}
					if (callback !== undefined) {
						callback ();
						}
					}
				});
			}
		}
	console.log ("startup");
	twStorageData.urlTwitterServer = appConsts.urlTwitterServer; //4/13/15 by DW
	twStorageData.embedModifyCallback = function (struct) { //3/30/17 by DW
		struct.html = replaceAll (struct.html, "src=\"//platform.twitter.com/widgets.js\"", "src=\"https://platform.twitter.com/widgets.js\"")
		console.log ("startup, embedModifyCallback: struct.html == " + struct.html);
		};
	
	appConsts.productname = serverConfig.productname;
	appConsts.productnameForDisplay = serverConfig.productnameForDisplay;
	appConsts.description = serverConfig.description;
	appConsts.version = serverConfig.version;
	$("#idVersionNumber").html ("v" + appConsts.version);
	
	riverBrowserData.openWindowCallback = function (url) {
		console.log ("callback in electronRiverUI/startup.");
		shellOpenUrl (url);
		};
	
	initMenus ();
	buildPagesMenu ();
	shellSetupSystemMenus ();
	
	hitCounter (); //9/4/14 by DW
	shellSetupIpcHandlers (); //3/24/17 by DW
	loadPrefsDialogHtml (); //3/25/17 by DW
	setupPanels (function () {
		console.log ("startup: appPrefs == " + jsonStringify (appPrefs));
		switchPanel (getURLParameter ("panel"));
		self.setInterval (everySecond, 1000); 
		self.setInterval (everyTwoSeconds, 2000); 
		self.setInterval (everyMinute, 60000); 
		});
	}
